#property copyright " Kris  2010 "                                //|
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 C'000,200,000' // SeaGreen
#property indicator_color2 C'000,200,000' // Green
#property indicator_color3 C'000,200,000' // Lime
#property indicator_color4 White //C'150,150,150' // Silver
#property indicator_color5 C'200,000,000' // Red
#property indicator_color6 C'200,000,000' // Crimson
#property indicator_color7 C'200,000,000' // Maroon
//---- input parameters
extern int MaxPeriod = 1440;  //Chart period cannot be higher than Daily
extern int StartDay  = 1;     // 0=Sunday, 1=Monday
extern int FontSize  = 10;     // Pivot label font size
extern bool Draw.ADR.Lines = true;

int Server.GMT.Offset.Hours = 1; //not used yet

//---- buffers
double BufferR3[];
double BufferR2[];
double BufferR1[];
double BufferPP[];
double BufferS1[];
double BufferS2[];
double BufferS3[];

double WH,WL,WC,PP,PD,PRH,PRL;
double S1,R1,S2,R2,S3,R3;
double last_week_high, last_week_low, last_week_close, this_week_open;

#define Day.Friday 5

int fri.shift = 0;
bool fri.shift.done = false;

int deinit() {
   ObjectDelete("PivR3");
   ObjectDelete("PivR2");
   ObjectDelete("PivR1");
   ObjectDelete("PivPP");
   ObjectDelete("PivS1");
   ObjectDelete("PivS2");
   ObjectDelete("PivS3");
   
	ObjectDelete("LabPivR3");
	ObjectDelete("LabPivR2");
	ObjectDelete("LabPivR1");
	ObjectDelete("LabPivPP");
	ObjectDelete("LabPivS1");
	ObjectDelete("LabPivS2");
	ObjectDelete("LabPivS3");
	
	Comment("");
	return(0); }

int SetFridayShiftValue()
{
  
  string symbl = "EURUSD";
  int shift = 0;
  
  int hour = TimeHour(iTime(symbl, PERIOD_H1, shift));
  int day = TimeDayOfWeek(iTime(symbl, PERIOD_H1, shift));
  
  int target.hour = 20 + Server.GMT.Offset.Hours;
  int target.day = Day.Friday;
  
  //not sure if these checks will work ??
  
  if ( target.hour >= 24 )
  {
    target.hour -= 24;
    target.day += 1;
  }

  if ( target.hour < 0 )
  {
    target.hour += 24;
    target.day -= 1;
  }
  
  if ( target.day == 6 ) target.day += 1; //avoid looking for saturday bars
  
  while ( ! ( hour == target.hour && day == target.day ) )
  {
    shift++;
    hour = TimeHour(iTime(symbl, PERIOD_H1, shift));
    day = TimeDayOfWeek(iTime(symbl, PERIOD_H1, shift));
    
    if ( shift > (24*8) ) //8 days back & no bar found with target.hour
    {
      shift = 0;
      break;  
    }
  }

  fri.shift = shift;
  
  fri.shift.done = true;
}

void CheckFridayShift()
{
  //on Fridays, check every 1 minute past the hour for passing Friday 8pm (incl GMT offset)
  if ( TimeMinute(TimeCurrent()) == 1 ) fri.shift.done = false;
  
  if ( ! fri.shift.done ) SetFridayShiftValue();
}

int init()
  {
   string short_name;

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,160);
   SetIndexBuffer(0,BufferR3);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,160);
   SetIndexBuffer(1,BufferR2);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,160);
   SetIndexBuffer(2,BufferR1);
      
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,167);
   SetIndexBuffer(3,BufferPP);
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,160);
   SetIndexBuffer(4,BufferS1);
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,160);
   SetIndexBuffer(5,BufferS2);
   
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,160);
   SetIndexBuffer(6,BufferS3);
   
   short_name="Bosuns Weekly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexDrawBegin(0,1);
   return(0);  }

double GetADRValue()
{
/*
  int First_av = 5;
  int Second_av = 10;
  int Third_av = 20;
*/

  int First_av = 5;
  int Second_av = 8;
  int Third_av = 13;

   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=First_av;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Second_av;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Third_av;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

   R5 = R5/First_av;
   R10 = R10/Second_av;
   R20 = R20/Third_av;
   RAvg  =  (R1+R5+R10+R20)/4; //RAvg  =  (R5+R10+R20)/3;new setting    
   
   return(RAvg);
}

int start()
{
  CheckFridayShift();
  
  double ADR = GetADRValue();
  string sADR = DoubleToStr(ADR/10, 0);
  
  if (Period() > MaxPeriod) return(0);
  int counted_bars=IndicatorCounted();
  int limit, i;
 
   string pad = "                  ";
   
  if (counted_bars==0)
  {
    ObjectCreate("PivR3", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivR3", pad + "R3",FontSize,"Consolas",indicator_color1);
    ObjectCreate("PivR2", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivR2", pad + "R2",FontSize,"Consolas",indicator_color2);
    ObjectCreate("PivR1", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivR1", pad + "R1",FontSize,"Consolas",indicator_color3);
    ObjectCreate("PivPP", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivPP", pad + "    ADR " + sADR,FontSize,"Consolas",indicator_color4);
    ObjectCreate("PivS1", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivS1", pad + "S1",FontSize,"Consolas",indicator_color5);
    ObjectCreate("PivS2", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivS2", pad + "S2",FontSize,"Consolas",indicator_color6);
    ObjectCreate("PivS3", OBJ_TEXT, 0,0,0);
    ObjectSetText("PivS3", pad + "S3",FontSize,"Consolas",indicator_color7);
  }

  if(counted_bars<0) return(-1);

  limit=(Bars-counted_bars)-1;

/*
#define ADR3  2.20
#define ADR2  1.45
#define ADR1  0.70


double ADR1 = 0.625;//0.618;//0.66;
double ADR2 = ADR1 * 2; //+ 1.118;//ADR1 * 2;// 1.45
double ADR3 = ADR1 * 3; //+ 1.500;//ADR1 * 3;// 2.20

double ADR1 = 0.66;
double ADR2 = 1.45;
double ADR3 = 2.20;

*/

double ADR2 = ADR / 1000;
double ADR1 = ADR2 / 2.29;//2.19;
double ADR3 = ADR2 * 1.61;
       
  //last_week_close = iOpen(Symbol(), PERIOD_H1, fri.shift);

  for(i=limit; i>=0;i--)
  
  {
    if ( StartDay==TimeDayOfWeek(Time[i]) && StartDay!=TimeDayOfWeek(Time[i+1]) )  
    {
      last_week_close=Close[i+1];
      //last_week_close = iOpen(Symbol(), PERIOD_H1, i + 1 + fri.shift);
      
      this_week_open=Open[i];
      //this_week_open=last_week_close;

      WH = last_week_high;
      WL = last_week_low;
      WC = last_week_close;
         
      if ( Draw.ADR.Lines )
      {
        R3 = WC + ( ADR * ADR3 * Point );
        R2 = WC + ( ADR * ADR2 * Point );         
        R1 = WC + ( ADR * ADR1 * Point );
        PP = WC;
        S1 = WC - ( ADR * ADR1 * Point );
        S2 = WC - ( ADR * ADR2 * Point );
        S3 = WC - ( ADR * ADR3 * Point );
      
/*      
       R3 = WC * ( 1.0312 * 1.0 );
       R2 = WC * ( 1.0161 * 1.0 );         
       R1 = WC * ( 1.0078 * 1.0 );
       PP = WC;
       S1 = WC * ( 0.9922 * 1.0 );
       S2 = WC * ( 0.9839 * 1.0 );
       S3 = WC * ( 0.9688 * 1.0 );
*/       
      }
      else
      {
       R3 = WC * 1.0625;
       R2 = WC * 1.0312;         
       R1 = WC * 1.0156;
       PP = WC;
       S1 = WC * 0.9844;
       S2 = WC * 0.9688;
       S3 = WC * 0.9375;
      }
			
      last_week_low  = Low[i];
      last_week_high = High[i];

      ObjectMove("PivR3", 0, Time[i],R3);
      ObjectMove("PivR2", 0, Time[i],R2);
      ObjectMove("PivR1", 0, Time[i],R1);
      ObjectMove("PivPP", 0, Time[i],PP);
      ObjectMove("PivS1", 0, Time[i],S1);
      ObjectMove("PivS2", 0, Time[i],S2);
      ObjectMove("PivS3", 0, Time[i],S3);
    }

    last_week_high=MathMax(last_week_high, High[i]);
    last_week_low=MathMin(last_week_low, Low[i]);
      
    BufferR3[i]=R3;
    BufferR2[i]=R2;
    BufferR1[i]=R1;
    BufferPP[i]=PP;
    BufferS1[i]=S1;
    BufferS2[i]=S2;
    BufferS3[i]=S3;

    DoLabel( "LabPivR3", BufferR3[0], indicator_color1 );
    DoLabel( "LabPivR2", BufferR2[0], indicator_color2 );
    DoLabel( "LabPivR1", BufferR1[0], indicator_color3 );
    DoLabel( "LabPivPP", BufferPP[0], indicator_color4 );
    DoLabel( "LabPivS1", BufferS1[0], indicator_color5 );
    DoLabel( "LabPivS2", BufferS2[0], indicator_color6 );
    DoLabel( "LabPivS3", BufferS3[0], indicator_color7 );
	}
	return(0); 
}
	
void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }      
//+-----------------------------------------------------------------------------------------+
//|                                         THE END                                         |
//+-----------------------------------------------------------------------------------------+